
/* clib_except.q: exception handling for the clib module 03-04-02 AG */

/* see except.q for explanation */

/* This file is part of the Q programming system.

   The Q programming system is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   The Q programming system is distributed in the hope that it will be
   useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

@-0x80000000

import clib;

public type ClibException : Exception = special const clib_err X;

islower C		= throw (clib_err (islower C));
isupper C		= throw (clib_err (isupper C));
isalpha C		= throw (clib_err (isalpha C));
isdigit C		= throw (clib_err (isdigit C));
isxdigit C		= throw (clib_err (isxdigit C));
isalnum C		= throw (clib_err (isalnum C));
ispunct C		= throw (clib_err (ispunct C));
isspace C		= throw (clib_err (isspace C));
isgraph C		= throw (clib_err (isgraph C));
isprint C		= throw (clib_err (isprint C));
iscntrl C		= throw (clib_err (iscntrl C));
isascii C		= throw (clib_err (isascii C));
tolower S		= throw (clib_err (tolower S));
toupper S		= throw (clib_err (toupper S));
freopen NAME MODE F	= throw (clib_err (freopen NAME MODE F));
ftell F			= throw (clib_err (ftell F));
fseek F N		= throw (clib_err (fseek F N));
tmpnam			= throw (clib_err tmpnam);
tmpfile			= throw (clib_err tmpfile);
intsize X		= throw (clib_err (intsize X));
uintsize X		= throw (clib_err (uintsize X));
readint F COUNT		= throw (clib_err (readint F COUNT));
readuint F COUNT	= throw (clib_err (readuint F COUNT));
readfloat F		= throw (clib_err (readfloat F));
readcfloat F		= throw (clib_err (readcfloat F));
readstr F COUNT		= throw (clib_err (readstr F COUNT));
writeint F COUNT X	= throw (clib_err (writeint F COUNT X));
writefloat F X		= throw (clib_err (writefloat F X));
writecfloat F X		= throw (clib_err (writecfloat F X));
printf FORMAT ARGS	= throw (clib_err (printf FORMAT ARGS));
fprintf F FORMAT ARGS	= throw (clib_err (fprintf F FORMAT ARGS));
sprintf FORMAT ARGS	= throw (clib_err (sprintf FORMAT ARGS));
scanf FORMAT		= throw (clib_err (scanf FORMAT));
fscanf F FORMAT		= throw (clib_err (fscanf F FORMAT));
sscanf S FORMAT		= throw (clib_err (sscanf S FORMAT));
rename OLD NEW		= throw (clib_err (rename OLD NEW));
unlink NAME		= throw (clib_err (unlink NAME));
getcwd			= throw (clib_err getcwd);
chdir NAME		= throw (clib_err (chdir NAME));
mkdir NAME		= throw (clib_err (mkdir NAME));
rmdir NAME		= throw (clib_err (rmdir NAME));
mkfifo NAME		= throw (clib_err (mkfifo NAME));
umask N			= throw (clib_err (umask N));
stat NAME		= throw (clib_err (stat NAME));
lstat NAME		= throw (clib_err (lstat NAME));
system CMD		= throw (clib_err (system CMD));
fork			= throw (clib_err fork);
exec PROG ARGS		= throw (clib_err (exec PROG ARGS));
exit N			= throw (clib_err (exit N));
kill SIG PID		= throw (clib_err (kill SIG PID));
getpid			= throw (clib_err getpid);
wait			= throw (clib_err wait);
waitpid PID		= throw (clib_err (waitpid PID));
status PID		= throw (clib_err (status PID));
getenv NAME		= throw (clib_err (getenv NAME));
setenv NAME VAL		= throw (clib_err (setenv NAME VAL));
isactive STATUS		= throw (clib_err (isactive STATUS));
isexited STATUS		= throw (clib_err (isexited STATUS));
exitstatus STATUS	= throw (clib_err (exitstatus STATUS));
issignaled STATUS	= throw (clib_err (issignaled STATUS));
termsig STATUS		= throw (clib_err (termsig STATUS));
isstopped STATUS	= throw (clib_err (isstopped STATUS));
stopsig STATUS		= throw (clib_err (stopsig STATUS));
thread_no THREAD	= throw (clib_err (thread_no THREAD));
this_thread		= throw (clib_err this_thread);
thread X		= throw (clib_err (thread X));
return X		= throw (clib_err (return X));
cancel THREAD		= throw (clib_err (cancel THREAD));
result THREAD		= throw (clib_err (result THREAD));
yield			= throw (clib_err yield);
active THREAD		= throw (clib_err (active THREAD));
canceled THREAD		= throw (clib_err (canceled THREAD));
schedule THREAD POL PRIO= throw (clib_err (schedule THREAD POL PRIO));
mutex			= throw (clib_err mutex);
errorchecking_mutex	= throw (clib_err errorchecking_mutex);
recursive_mutex		= throw (clib_err recursive_mutex);
lock MUTEX		= throw (clib_err (lock MUTEX));
unlock MUTEX		= throw (clib_err (unlock MUTEX));
try MUTEX		= throw (clib_err (try MUTEX));
cond			= throw (clib_err cond);
signal COND		= throw (clib_err (signal COND));
broadcast COND		= throw (clib_err (broadcast COND));
suspend COND		= throw (clib_err (suspend COND));
sem			= throw (clib_err sem);
send SEM X		= throw (clib_err (send SEM X));
receive SEM		= throw (clib_err (receive SEM));
sem_size SEM		= throw (clib_err (sem_size SEM));
timezone		= throw (clib_err timezone);
ctime T			= throw (clib_err (ctime T));
gmtime T		= throw (clib_err (gmtime T));
clock			= throw (clib_err clock);
fnmatch PATTERN S	= throw (clib_err (fnmatch PATTERN S));
glob PATTERN		= throw (clib_err (glob PATTERN));
regmatch OPTS REGEX S	= throw (clib_err (regmatch OPTS REGEX S));
regnext			= throw (clib_err regnext);
regdone			= throw (clib_err regdone);
regex OPTS REGEX S EXPR	= throw (clib_err (regex OPTS REGEX S EXPR));
regstart		= throw (clib_err regstart);
regskip			= throw (clib_err regskip);
reg N			= throw (clib_err (reg N));
regpos N		= throw (clib_err (regpos N));
regend N		= throw (clib_err (regend N));
regs			= throw (clib_err regs);
pow M N			= throw (clib_err (pow M N));
root M N		= throw (clib_err (root M N));
intsqrt M		= throw (clib_err (intsqrt M));
powmod K M N		= throw (clib_err (powmod K M N));
invmod K M		= throw (clib_err (invmod K M));
isprime N		= throw (clib_err (isprime N));
gcd M N			= throw (clib_err (gcd M N));
lcm M N			= throw (clib_err (lcm M N));
fact M N		= throw (clib_err (fact M N));
rem M N			= throw (clib_err (rem M N));
jacobi M N		= throw (clib_err (jacobi M N));
sort P Xs		= throw (clib_err (sort P Xs));
