
/* popen2.q: clib named pipes and process example showing how to create
   a bidirectional pipe to a child process */

popen2 CMD    = mkfifo IN_S || mkfifo OUT_S || spawn2 CMD IN_S OUT_S
		where (IN_S, OUT_S) = (tmpnam, tmpnam);

spawn2 CMD IN_S OUT_S
	      = freopen IN_S "r" INPUT || freopen OUT_S "w" OUTPUT ||
		exec "/bin/sh" ["/bin/sh", "-c", CMD] 
		    if fork = 0;
	      = unlink IN_S || unlink OUT_S || (IN, OUT)
		    otherwise
		where (IN, OUT) = (fopen IN_S "w", fopen OUT_S "r");

/* Here is an example: pipe a list of strings into the `sort' program and
   return the sorted list. */

mysort STRL   = do (fprintf IN "%s\n") STRL || fclose IN || digest OUT
		where (IN, OUT) = popen2 "sort";

digest OUT    = [] if feof OUT;
	      = [freads OUT|digest OUT] otherwise;
