
/*  A Bison parser, made from /root/src/q/q-3.2/src/qmparse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	STRING	257
#define	LINE	258
#define	INTERACT	259
#define	SOURCE	260
#define	AND	261
#define	AS	262
#define	CONST	263
#define	DEF	264
#define	DIV	265
#define	ELSE	266
#define	EXTERN	267
#define	IF	268
#define	IMPORT	269
#define	IN	270
#define	INCLUDE	271
#define	MOD	272
#define	NOT	273
#define	OR	274
#define	OTHERWISE	275
#define	PRIVATE	276
#define	PUBLIC	277
#define	SPECIAL	278
#define	THEN	279
#define	TYPE	280
#define	UNDEF	281
#define	VAR	282
#define	WHERE	283
#define	CAT	284
#define	DBAR	285
#define	LEQ	286
#define	GEQ	287
#define	NEQ	288
#define	_DEF_	289
#define	_UNDEF_	290
#define	_IMPORT_	291
#define	_COPYING_	292
#define	_HELP_	293
#define	_EDIT_	294
#define	_PATH_	295
#define	_PROMPT_	296
#define	_HISTFILE_	297
#define	_HISTSIZE_	298
#define	_STACKSIZE_	299
#define	_MEMSIZE_	300
#define	_STATS_	301
#define	_RUN_	302
#define	_SAVE_	303
#define	_LOAD_	304
#define	_CLEAR_	305
#define	_BREAK_	306
#define	_DEBUG_	307
#define	_ECHO_	308
#define	_CHDIR_	309
#define	_PWD_	310
#define	_LS_	311
#define	_WHICH_	312
#define	_SOURCE_	313
#define	_WHO_	314
#define	_WHOS_	315
#define	_IMPORTS_	316
#define	_MODULES_	317
#define	_COMPLETION_MATCHES_	318
#define	_DEC_	319
#define	_HEX_	320
#define	_OCT_	321
#define	_STD_	322
#define	_SCI_	323
#define	_FIX_	324
#define	_FORMAT_	325
#define	XID	326
#define	ID	327
#define	STR	328
#define	INT	329
#define	FLOAT	330
#define	ARG	331
#define	ERR	332
#define	ARGERR	333
#define	STRERR	334

#line 2 "qmparse.y"


/* qmparse.y: Q machine expression parser */

/* Special case constructs (unary minus, 1-tuples) cause a number of parsing
   conflicts which are resolved correctly. */

/*  Q eQuational Programming System
    Copyright (c) 1991-2002 by Albert Graef
    <ag@muwiinfa.geschichte.uni-mainz.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

/* make sure we have bison */

#ifndef YYBISON
#error "Sorry, this program requires bison."
#endif

#include "qdefs.h"

extern char *prompt;
extern int pmode;

static char		signon[] = Q_SIGNON;
static char		copying[] = COPYING;

static char *psource = "";

static char  *save_file = NULL;
static char *base;

static THREAD *thr;

/*

This module implements a parser for Q expressions and the special
constructs (def, undef, etc.) permitted in the interactive evaluation
loop. The parser can be run in four different modes signalled by special
leading tokens:

- STRING: read a single expression from a null-terminated string.

- LINE: read an expression terminated with newline from a file.

- INTERACT: read and evaluate a command (including def's,
  undef's and shell escapes) from a null-terminated string.

- SOURCE: read and evaluate commands from a file

*/

static swap(), pushbin(), pushun(), clean();
static init_stats(), fini_stats(), print_stats();
static copyright(), shell(), expression(), assignment(), unassignment(),
  sethistfile(), sethistsize(), help(), edit(), save_vars(), clear_vars(),
  add_import(), del_import(), clear_imports(), who(), whos(), import_list(),
  modules();
static strparam(), intparam(), boolparam(), boolstrparam(), strlist(),
  printstr();

#ifndef USE_READLINE
static histwarn();
#endif

#define MAXARGC 1000

#line 84 "qmparse.y"
typedef union {
  int ival;
  mpz_t zval;
  double fval;
  char *sval;
  EXPR *xval;
  struct {
    char **v;
    int c;
  } aval;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		288
#define	YYFLAG		-32768
#define	YYNTBASE	102

#define YYTRANSLATE(x) ((unsigned)(x) <= 334 ? yytranslate[x] : 139)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    81,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    82,     2,    94,     2,     2,     2,    96,    84,
    85,    92,    91,    86,    90,     2,    93,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    83,    88,
    87,    89,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
   100,     2,   101,    95,     2,    97,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,    99,     2,    98,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     6,    10,    13,    16,    17,    18,    20,    22,
    25,    27,    31,    33,    36,    39,    41,    44,    46,    49,
    51,    54,    56,    59,    61,    63,    65,    67,    69,    72,
    74,    77,    79,    82,    84,    87,    89,    92,    94,    97,
    99,   102,   104,   106,   108,   111,   114,   116,   119,   121,
   124,   126,   129,   131,   134,   136,   139,   142,   144,   147,
   149,   152,   154,   157,   160,   162,   164,   166,   169,   171,
   172,   177,   179,   182,   184,   186,   189,   191,   193,   197,
   198,   201,   202,   205,   207,   209,   211,   215,   219,   221,
   225,   227,   229,   233,   235,   239,   241,   243,   245,   247,
   249,   251,   253,   257,   259,   263,   265,   267,   269,   271,
   273,   275,   277,   279,   283,   287,   289,   291,   293,   296,
   298,   302,   304,   306,   308,   310,   312,   315,   317,   320,
   323,   326,   329,   331,   333,   335,   339,   341,   343,   345,
   348,   350,   352,   354,   356,   358,   360,   362,   364,   368,
   370,   373,   378,   383,   388,   393,   398,   403,   408,   413,
   418,   423,   428,   431,   435,   439,   445,   451,   454,   458,
   460,   462,   466,   470,   472,   476,   480,   482,   484,   486,
   488,   490,   492,   494,   496,   498,   500,   502,   504,   507,
   509,   511,   513,   515,   517,   520,   522,   524,   526,   528,
   530,   532
};

static const short yyrhs[] = {     3,
   122,     0,     4,   122,     0,     4,   122,    81,     0,     5,
   103,     0,     6,   103,     0,     0,     0,    82,     0,   104,
     0,   104,    83,     0,   105,     0,   104,    83,   105,     0,
   122,     0,    35,   115,     0,    36,   117,     0,    38,     0,
    64,   114,     0,    39,     0,    39,   114,     0,    41,     0,
    41,   114,     0,    42,     0,    42,   114,     0,    71,     0,
    65,     0,    66,     0,    67,     0,    68,     0,    68,   114,
     0,    69,     0,    69,   114,     0,    70,     0,    70,   114,
     0,    43,     0,    43,   114,     0,    44,     0,    44,   114,
     0,    45,     0,    45,   114,     0,    46,     0,    46,   114,
     0,    47,     0,    56,     0,    55,     0,    55,   114,     0,
    57,   113,     0,    53,     0,    53,   114,     0,    52,     0,
    52,   114,     0,    54,     0,    54,   114,     0,    58,     0,
    58,   114,     0,    40,     0,    40,   114,     0,    59,   114,
     0,    50,     0,    50,   114,     0,    49,     0,    49,   114,
     0,    51,     0,    51,   107,     0,    37,   113,     0,    62,
     0,    63,     0,    60,     0,    61,   109,     0,    48,     0,
     0,    48,   114,   106,   112,     0,   108,     0,   107,   108,
     0,    73,     0,   110,     0,   109,   110,     0,   111,     0,
    73,     0,    84,   138,    85,     0,     0,   112,   114,     0,
     0,   113,   114,     0,    77,     0,    79,     0,   116,     0,
   115,    86,   116,     0,   119,    87,   122,     0,   118,     0,
   117,    86,   118,     0,    73,     0,   120,     0,   119,    31,
   120,     0,   125,     0,   125,   121,   125,     0,    88,     0,
    89,     0,    32,     0,    33,     0,    34,     0,    16,     0,
   123,     0,   122,    31,   123,     0,   125,     0,   125,   124,
   125,     0,    88,     0,    89,     0,    87,     0,    32,     0,
    33,     0,    34,     0,    16,     0,   127,     0,   125,   126,
   127,     0,   125,    90,   127,     0,    91,     0,    30,     0,
    20,     0,    20,    12,     0,   129,     0,   127,   128,   129,
     0,    92,     0,    93,     0,    11,     0,    18,     0,     7,
     0,     7,    25,     0,   131,     0,    90,    75,     0,    90,
    76,     0,    90,   129,     0,   130,   129,     0,    94,     0,
    19,     0,   133,     0,   133,   132,   131,     0,    95,     0,
    82,     0,   135,     0,   133,   135,     0,    96,     0,    97,
     0,    98,     0,    75,     0,    76,     0,    74,     0,    80,
     0,    73,     0,    84,   138,    85,     0,    72,     0,   134,
   135,     0,    84,   122,    31,    85,     0,    84,    31,   123,
    85,     0,    84,   125,   124,    85,     0,    84,   124,   125,
    85,     0,    84,   125,   126,    85,     0,    84,   125,    90,
    85,     0,    84,   126,   127,    85,     0,    84,   127,   128,
    85,     0,    84,   128,   129,    85,     0,    84,   133,   132,
    85,     0,    84,   132,   131,    85,     0,    84,    85,     0,
    84,   135,    85,     0,    84,   122,    85,     0,    84,   122,
    99,   122,    85,     0,    84,   122,    86,   136,    85,     0,
   100,   101,     0,   100,   137,   101,     0,     1,     0,   122,
     0,   122,    99,   122,     0,   122,    86,   136,     0,   122,
     0,   122,    99,   122,     0,   122,    86,   137,     0,    31,
     0,    88,     0,    89,     0,    87,     0,    32,     0,    33,
     0,    34,     0,    16,     0,    30,     0,    91,     0,    90,
     0,    20,     0,    20,    12,     0,    92,     0,    93,     0,
    11,     0,    18,     0,     7,     0,     7,    25,     0,    94,
     0,    19,     0,    96,     0,    97,     0,    98,     0,    95,
     0,    82,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   138,   139,   140,   142,   143,   144,   149,   150,   152,   153,
   156,   157,   160,   165,   167,   169,   172,   200,   211,   225,
   231,   247,   253,   265,   280,   283,   286,   289,   296,   312,
   319,   335,   342,   358,   367,   377,   386,   396,   402,   419,
   425,   443,   446,   459,   473,   501,   525,   531,   541,   547,
   557,   563,   578,   584,   616,   625,   646,   669,   686,   710,
   725,   744,   747,   749,   772,   775,   778,   781,   783,   786,
   802,   815,   815,   817,   819,   819,   821,   823,   823,   825,
   832,   855,   869,   892,   893,   897,   898,   901,   905,   906,
   909,   913,   914,   918,   919,   923,   924,   925,   926,   927,
   928,   931,   932,   936,   937,   941,   942,   943,   944,   945,
   946,   947,   950,   951,   953,   957,   958,   959,   960,   963,
   964,   968,   969,   970,   971,   972,   973,   978,   979,   981,
   982,   983,   986,   987,   990,   991,   995,   996,   999,  1000,
  1004,  1005,  1006,  1012,  1013,  1014,  1015,  1019,  1021,  1025,
  1029,  1034,  1037,  1042,  1045,  1050,  1053,  1056,  1061,  1064,
  1069,  1072,  1079,  1081,  1084,  1085,  1087,  1093,  1095,  1099,
  1103,  1106,  1108,  1112,  1115,  1117,  1121,  1122,  1123,  1124,
  1125,  1126,  1127,  1128,  1129,  1130,  1131,  1132,  1133,  1134,
  1135,  1136,  1137,  1138,  1139,  1140,  1141,  1142,  1143,  1144,
  1145,  1146
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","STRING",
"LINE","INTERACT","SOURCE","AND","AS","CONST","DEF","DIV","ELSE","EXTERN","IF",
"IMPORT","IN","INCLUDE","MOD","NOT","OR","OTHERWISE","PRIVATE","PUBLIC","SPECIAL",
"THEN","TYPE","UNDEF","VAR","WHERE","CAT","DBAR","LEQ","GEQ","NEQ","_DEF_","_UNDEF_",
"_IMPORT_","_COPYING_","_HELP_","_EDIT_","_PATH_","_PROMPT_","_HISTFILE_","_HISTSIZE_",
"_STACKSIZE_","_MEMSIZE_","_STATS_","_RUN_","_SAVE_","_LOAD_","_CLEAR_","_BREAK_",
"_DEBUG_","_ECHO_","_CHDIR_","_PWD_","_LS_","_WHICH_","_SOURCE_","_WHO_","_WHOS_",
"_IMPORTS_","_MODULES_","_COMPLETION_MATCHES_","_DEC_","_HEX_","_OCT_","_STD_",
"_SCI_","_FIX_","_FORMAT_","XID","ID","STR","INT","FLOAT","ARG","ERR","ARGERR",
"STRERR","'\\n'","'!'","';'","'('","')'","','","'='","'<'","'>'","'-'","'+'",
"'*'","'/'","'#'","'^'","'\\''","'`'","'~'","'|'","'['","']'","source","input",
"commands","command","@1","clearsyms","clearsym","whossyms","whossym","symbol",
"opt_arg_list","arg_list","arg","defs","def","undefs","undef","lexpression",
"lrelation","lrelop","expression","relation","relop","addition","addop","multiplication",
"mulop","unary","unop","script","scriptop","application","quoteop","primary",
"tuple_elems","list_elems","op", NULL
};
#endif

static const short yyr1[] = {     0,
   102,   102,   102,   102,   102,   102,   103,   103,   103,   103,
   104,   104,   105,   105,   105,   105,   105,   105,   105,   105,
   105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
   105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
   105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
   105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
   105,   105,   105,   105,   105,   105,   105,   105,   105,   106,
   105,   107,   107,   108,   109,   109,   110,   111,   111,   112,
   112,   113,   113,   114,   114,   115,   115,   116,   117,   117,
   118,   119,   119,   120,   120,   121,   121,   121,   121,   121,
   121,   122,   122,   123,   123,   124,   124,   124,   124,   124,
   124,   124,   125,   125,   125,   126,   126,   126,   126,   127,
   127,   128,   128,   128,   128,   128,   128,   129,   129,   129,
   129,   129,   130,   130,   131,   131,   132,   132,   133,   133,
   134,   134,   134,   135,   135,   135,   135,   135,   135,   135,
   135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
   135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
   136,   136,   136,   137,   137,   137,   138,   138,   138,   138,
   138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
   138,   138,   138,   138,   138,   138,   138,   138,   138,   138,
   138,   138
};

static const short yyr2[] = {     0,
     2,     2,     3,     2,     2,     0,     0,     1,     1,     2,
     1,     3,     1,     2,     2,     1,     2,     1,     2,     1,
     2,     1,     2,     1,     1,     1,     1,     1,     2,     1,
     2,     1,     2,     1,     2,     1,     2,     1,     2,     1,
     2,     1,     1,     1,     2,     2,     1,     2,     1,     2,
     1,     2,     1,     2,     1,     2,     2,     1,     2,     1,
     2,     1,     2,     2,     1,     1,     1,     2,     1,     0,
     4,     1,     2,     1,     1,     2,     1,     1,     3,     0,
     2,     0,     2,     1,     1,     1,     3,     3,     1,     3,
     1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
     1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
     1,     1,     1,     3,     3,     1,     1,     1,     2,     1,
     3,     1,     1,     1,     1,     1,     2,     1,     2,     2,
     2,     2,     1,     1,     1,     3,     1,     1,     1,     2,
     1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
     2,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     2,     3,     3,     5,     5,     2,     3,     1,
     1,     3,     3,     1,     3,     3,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
     1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
     1,     1
};

static const short yydefact[] = {     6,
     0,     0,     0,     0,   170,   134,   150,   148,   146,   144,
   145,   147,     0,     0,   133,   141,   142,   143,     0,     1,
   102,   104,   113,   120,     0,   128,     0,     0,   139,     2,
     0,     0,    82,    16,    18,    55,    20,    22,    34,    36,
    38,    40,    42,    69,    60,    58,    62,    49,    47,    51,
    44,    43,    82,    53,     0,    67,     0,    65,    66,     0,
    25,    26,    27,    28,    30,    32,    24,     8,     4,     9,
    11,    13,     5,   126,   124,   112,   125,   134,   118,   117,
     0,   109,   110,   111,   138,   163,   108,   106,   107,     0,
   116,   122,   123,   133,   137,   141,   142,   143,     0,     0,
   104,     0,   113,     0,     0,     0,   139,     0,   129,   130,
   131,   168,   174,     0,     0,   112,   118,   117,   109,   110,
   111,   108,   106,   107,     0,   116,     0,     0,   126,   124,
   125,   122,   123,     0,   132,   138,   137,     0,   140,   151,
     3,    14,    86,     0,    92,    94,    91,    15,    89,    64,
    84,    85,    19,    56,    21,    23,    35,    37,    39,    41,
    70,    61,    59,    74,    63,    72,    50,    48,    52,    45,
    46,    54,    57,    78,     0,    68,    75,    77,    17,    29,
    31,    33,     0,   127,   119,     0,     0,   165,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   164,
   149,     0,     0,   169,   103,   119,   115,   105,   114,   127,
   121,   136,     0,     0,     0,   101,    98,    99,   100,    96,
    97,     0,     0,    83,    80,    73,   194,   192,   184,   193,
   197,   188,   185,   177,   181,   182,   183,   202,   180,   178,
   179,   187,   186,   190,   191,   196,   201,   198,   199,   200,
     0,    76,    12,   153,   152,   171,     0,     0,   155,   157,
   154,   156,   158,   159,   160,   162,   161,   176,   175,    87,
    93,    88,    95,    90,    71,   195,   189,    79,     0,     0,
   167,   166,    81,   173,   172,     0,     0,     0
};

static const short yydefgoto[] = {   286,
    69,    70,    71,   225,   165,   166,   176,   177,   178,   275,
   150,   224,   142,   143,   148,   149,   144,   145,   222,    72,
    21,   100,    22,   128,    23,   134,    24,    25,    26,   105,
    27,    28,    29,   257,   114,   108
};

static const short yypact[] = {   120,
   713,   713,   245,   245,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   418,   742,-32768,-32768,-32768,-32768,   157,     5,
-32768,   183,    35,-32768,   713,-32768,    64,   819,-32768,     0,
   713,   -30,-32768,-32768,   -19,   -19,   -19,   -19,   -19,   -19,
   -19,   -19,-32768,   -19,   -19,   -19,   -10,   -19,   -19,   -19,
   -19,-32768,-32768,   -19,   -19,-32768,   -11,-32768,-32768,   -19,
-32768,-32768,-32768,   -19,   -19,   -19,-32768,-32768,-32768,   -22,
-32768,     5,-32768,    -8,   -18,   -17,   -15,   -13,     3,     4,
   498,    18,    19,    30,    36,-32768,    46,    47,    48,   534,
    50,    57,    58,    82,    83,    84,    90,    92,    21,   713,
   913,   713,    35,   713,   819,   452,    96,   101,    98,   771,
-32768,-32768,   -20,   -27,   713,-32768,    74,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   713,-32768,   713,   713,    51,-32768,
-32768,-32768,-32768,   713,-32768,-32768,-32768,   819,-32768,-32768,
-32768,    22,-32768,    23,-32768,   918,-32768,   104,-32768,   -19,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   -10,-32768,-32768,-32768,-32768,-32768,
   -19,-32768,-32768,-32768,   894,   -11,-32768,-32768,-32768,-32768,
-32768,-32768,   330,   102,   106,   107,   565,-32768,   713,   713,
    27,   596,   625,   655,    -2,   684,   112,   115,   800,-32768,
-32768,   713,   713,-32768,-32768,-32768,    35,    39,    35,-32768,
-32768,-32768,   713,   713,   713,-32768,-32768,-32768,-32768,-32768,
-32768,   713,   -30,-32768,-32768,-32768,    88,-32768,-32768,-32768,
-32768,   192,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   121,-32768,-32768,-32768,-32768,    80,   123,    20,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,     5,-32768,
-32768,     5,    39,-32768,   -19,-32768,-32768,-32768,   713,   713,
-32768,-32768,-32768,-32768,     5,   205,   209,-32768
};

static const short yypgoto[] = {-32768,
   206,-32768,    29,-32768,-32768,    53,-32768,    43,-32768,-32768,
   158,   -16,-32768,     7,-32768,     2,-32768,     8,-32768,    -1,
   -78,   -14,    14,     1,    -9,    -3,   -12,-32768,   -98,   -21,
   208,-32768,    28,   -56,    24,    49
};


#define	YYLAST		1009


static const short yytable[] = {    20,
    30,   111,   186,   103,   129,   138,   198,   127,   130,   104,
   115,    99,   135,   102,   185,   131,   184,   113,   153,   154,
   155,   156,   157,   158,   159,   160,   101,   161,   162,   163,
   115,   167,   168,   169,   170,   115,   205,   172,   173,   212,
   107,   129,   147,   179,   146,   130,   117,   180,   181,   182,
   115,   187,   131,   214,   139,   140,   118,   151,   117,   152,
   183,   174,   164,  -135,     5,   202,  -192,  -184,   118,  -193,
  -135,  -197,   175,   204,  -135,   210,  -194,   111,   203,  -135,
   141,  -135,   263,  -135,   199,   206,   193,  -188,  -185,   132,
   133,   197,   195,  -135,  -135,  -135,  -135,  -135,  -144,   196,
   212,   194,  -181,  -182,   282,   188,   189,   213,   205,   215,
   115,   259,   276,   191,  -183,   207,   125,   126,   209,   190,
  -202,   211,     1,     2,     3,     4,   132,   133,   125,   126,
  -180,  -178,  -179,   139,  -186,     7,     8,     9,    10,    11,
   208,  -190,  -191,    12,  -135,   136,  -135,    13,  -135,  -135,
  -135,  -135,  -135,  -135,  -135,  -135,  -135,     5,   137,    16,
    17,    18,  -135,    19,  -135,   279,  -196,  -201,  -198,  -144,
  -144,  -144,  -144,  -144,  -199,     6,  -200,  -144,   280,  -144,
   200,  -144,   207,   211,   209,   201,  -195,   256,   258,   223,
  -189,   254,  -144,  -144,  -144,  -144,   265,  -144,   116,   266,
   113,   269,   117,   277,   287,   278,   208,   281,   288,    73,
   171,   253,   118,   272,   119,   120,   121,   226,   252,   270,
   106,   271,   284,   251,   274,   268,   146,   146,     7,     8,
     9,    10,    11,     0,     0,   273,    12,     0,     0,     0,
    13,     0,     0,     0,    -7,     5,    14,     0,     0,     0,
    15,     0,    16,    17,    18,     0,    19,   112,   283,     0,
     0,     0,     0,     6,     0,     0,     0,     0,     0,   122,
   123,   124,   125,   126,     0,     0,     0,   256,   285,    31,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
    42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    67,     7,     8,     9,    10,
    11,     0,     0,     0,    12,     0,    68,     0,    13,   -10,
     5,     0,     0,     0,    14,     0,     0,     0,    15,     0,
    16,    17,    18,     0,    19,     0,     0,     0,     6,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,     7,     8,     9,    10,    11,     0,     0,     0,    12,
     0,     0,     0,    13,     0,     0,     0,     0,     5,    14,
     0,     0,     0,    15,    74,    16,    17,    18,    75,    19,
     0,     0,     0,    76,     0,    77,    78,    79,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    80,    81,    82,
    83,    84,     5,     0,     0,     0,     0,     0,  -135,     0,
     0,     0,  -135,     0,     0,     0,     0,  -135,     0,  -135,
     0,  -135,     0,     0,     0,     0,     0,     0,     0,     0,
     0,  -135,  -135,  -135,  -135,  -135,     0,     0,     0,     7,
     8,     9,    10,    11,     0,     0,     0,    12,     5,    85,
     0,    13,    86,     0,    87,    88,    89,    90,    91,    92,
    93,    94,    95,    96,    97,    98,     6,    19,     0,     0,
     0,     0,     0,     7,     8,     9,    10,    11,     0,     0,
     0,    12,     0,   136,     5,    13,  -135,  -135,  -135,  -135,
  -135,  -135,  -135,  -135,  -135,     0,   137,    16,    17,    18,
  -135,    19,     6,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     5,     0,     0,     0,     7,
     8,     9,    10,    11,     0,     0,     0,    12,     0,     0,
     0,    13,  -177,     6,     0,     0,     0,    14,     0,     0,
     0,    15,     0,    16,    17,    18,     5,    19,     0,     0,
     0,     0,     0,     0,     0,     7,     8,     9,   109,   110,
     0,     0,     0,    12,     6,     0,     0,    13,  -187,     0,
     0,     0,     0,    14,     0,     5,     0,    15,     0,    16,
    17,    18,     0,    19,     0,     0,     7,     8,     9,    10,
    11,     0,     0,     6,    12,     0,     0,     0,    13,   255,
     0,     0,     0,     0,    14,     5,     0,     0,    15,     0,
    16,    17,    18,     0,    19,     0,     0,     7,     8,     9,
    10,    11,     0,     6,     0,    12,     0,     0,     0,    13,
   260,     0,     0,     0,     5,    14,     0,     0,     0,    15,
     0,    16,    17,    18,     0,    19,     7,     8,     9,    10,
    11,     0,     6,     0,    12,     0,     0,     0,    13,   261,
     0,     0,     0,     5,    14,     0,     0,     0,    15,     0,
    16,    17,    18,     0,    19,     0,     7,     8,     9,    10,
    11,     6,     0,     0,    12,     0,     0,     0,    13,   262,
     0,     0,     5,     0,    14,     0,     0,     0,    15,     0,
    16,    17,    18,     0,    19,     7,     8,     9,    10,    11,
     6,     0,     0,    12,     0,     0,     0,    13,   264,     0,
     0,  -145,     0,    14,     0,     0,     0,    15,     0,    16,
    17,    18,     0,    19,     7,     8,     9,    10,    11,     0,
     0,     0,    12,     0,     0,     0,    13,     0,     0,     0,
     5,     0,    14,     0,     0,     0,    15,     0,    16,    17,
    18,     0,    19,     7,     8,     9,   109,   110,     0,     5,
     0,    12,     0,     0,     0,    13,     0,     0,     0,     0,
     0,    14,     0,     0,     0,    15,     0,    16,    17,    18,
     0,    19,  -145,  -145,  -145,  -145,  -145,     0,     0,     0,
  -145,     0,  -145,     0,  -145,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,  -145,  -145,  -145,  -145,     0,
  -145,     7,     8,     9,    10,    11,     0,     0,     0,    12,
     0,     0,     0,    13,   267,     0,     0,     0,     0,     0,
     7,     8,     9,    10,    11,    16,    17,    18,    12,    19,
   227,     0,    13,     0,   228,     0,     0,     0,     0,   229,
     0,   230,   231,   232,    16,    17,    18,     0,    19,     0,
     0,     0,     0,   233,   234,   235,   236,   237,   116,     0,
     0,     0,   117,   216,     0,     0,     0,   117,     0,     0,
     0,     0,   118,     0,   119,   120,   121,   118,     0,   217,
   218,   219,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   238,     0,     0,     0,     0,
   239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
   249,   250,     0,     0,     0,     0,     0,     0,     0,   122,
   123,   124,   192,   126,     0,   220,   221,   125,   126
};

static const short yycheck[] = {     1,
     2,    14,    81,    13,     7,    27,   105,    22,    11,    13,
    31,    13,    25,    13,    12,    18,    25,    19,    35,    36,
    37,    38,    39,    40,    41,    42,    13,    44,    45,    46,
    31,    48,    49,    50,    51,    31,   115,    54,    55,   138,
    13,     7,    73,    60,    31,    11,    20,    64,    65,    66,
    31,    31,    18,    31,    27,    28,    30,    77,    20,    79,
    83,    73,    73,     0,     1,    86,    85,    85,    30,    85,
     7,    85,    84,   101,    11,    25,    85,    90,    99,    16,
    81,    18,    85,    20,   106,    12,   101,    85,    85,    92,
    93,   104,   102,    30,    31,    32,    33,    34,     1,   103,
   199,   101,    85,    85,    85,    85,    86,    86,   187,    87,
    31,    85,    25,   100,    85,   125,    90,    91,   128,    99,
    85,   134,     3,     4,     5,     6,    92,    93,    90,    91,
    85,    85,    85,   106,    85,    72,    73,    74,    75,    76,
   127,    85,    85,    80,    81,    82,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,     1,    95,    96,
    97,    98,    99,   100,   101,    86,    85,    85,    85,    72,
    73,    74,    75,    76,    85,    19,    85,    80,    99,    82,
    85,    84,   192,   196,   194,    85,    85,   189,   190,    86,
    85,    85,    95,    96,    97,    98,    85,   100,    16,    85,
   202,   203,    20,    12,     0,    85,   193,    85,     0,     4,
    53,   183,    30,   215,    32,    33,    34,   165,   176,   213,
    13,   214,   279,   175,   223,   202,   213,   214,    72,    73,
    74,    75,    76,    -1,    -1,   222,    80,    -1,    -1,    -1,
    84,    -1,    -1,    -1,     0,     1,    90,    -1,    -1,    -1,
    94,    -1,    96,    97,    98,    -1,   100,   101,   275,    -1,
    -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    87,
    88,    89,    90,    91,    -1,    -1,    -1,   279,   280,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    -1,    -1,    -1,    80,    -1,    82,    -1,    84,     0,
     1,    -1,    -1,    -1,    90,    -1,    -1,    -1,    94,    -1,
    96,    97,    98,    -1,   100,    -1,    -1,    -1,    19,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
    61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
    -1,    -1,    -1,    84,    -1,    -1,    -1,    -1,     1,    90,
    -1,    -1,    -1,    94,     7,    96,    97,    98,    11,   100,
    -1,    -1,    -1,    16,    -1,    18,    19,    20,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
    33,    34,     1,    -1,    -1,    -1,    -1,    -1,     7,    -1,
    -1,    -1,    11,    -1,    -1,    -1,    -1,    16,    -1,    18,
    -1,    20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    30,    31,    32,    33,    34,    -1,    -1,    -1,    72,
    73,    74,    75,    76,    -1,    -1,    -1,    80,     1,    82,
    -1,    84,    85,    -1,    87,    88,    89,    90,    91,    92,
    93,    94,    95,    96,    97,    98,    19,   100,    -1,    -1,
    -1,    -1,    -1,    72,    73,    74,    75,    76,    -1,    -1,
    -1,    80,    -1,    82,     1,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,    -1,    95,    96,    97,    98,
    99,   100,    19,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    72,
    73,    74,    75,    76,    -1,    -1,    -1,    80,    -1,    -1,
    -1,    84,    85,    19,    -1,    -1,    -1,    90,    -1,    -1,
    -1,    94,    -1,    96,    97,    98,     1,   100,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    72,    73,    74,    75,    76,
    -1,    -1,    -1,    80,    19,    -1,    -1,    84,    85,    -1,
    -1,    -1,    -1,    90,    -1,     1,    -1,    94,    -1,    96,
    97,    98,    -1,   100,    -1,    -1,    72,    73,    74,    75,
    76,    -1,    -1,    19,    80,    -1,    -1,    -1,    84,    85,
    -1,    -1,    -1,    -1,    90,     1,    -1,    -1,    94,    -1,
    96,    97,    98,    -1,   100,    -1,    -1,    72,    73,    74,
    75,    76,    -1,    19,    -1,    80,    -1,    -1,    -1,    84,
    85,    -1,    -1,    -1,     1,    90,    -1,    -1,    -1,    94,
    -1,    96,    97,    98,    -1,   100,    72,    73,    74,    75,
    76,    -1,    19,    -1,    80,    -1,    -1,    -1,    84,    85,
    -1,    -1,    -1,     1,    90,    -1,    -1,    -1,    94,    -1,
    96,    97,    98,    -1,   100,    -1,    72,    73,    74,    75,
    76,    19,    -1,    -1,    80,    -1,    -1,    -1,    84,    85,
    -1,    -1,     1,    -1,    90,    -1,    -1,    -1,    94,    -1,
    96,    97,    98,    -1,   100,    72,    73,    74,    75,    76,
    19,    -1,    -1,    80,    -1,    -1,    -1,    84,    85,    -1,
    -1,     1,    -1,    90,    -1,    -1,    -1,    94,    -1,    96,
    97,    98,    -1,   100,    72,    73,    74,    75,    76,    -1,
    -1,    -1,    80,    -1,    -1,    -1,    84,    -1,    -1,    -1,
     1,    -1,    90,    -1,    -1,    -1,    94,    -1,    96,    97,
    98,    -1,   100,    72,    73,    74,    75,    76,    -1,     1,
    -1,    80,    -1,    -1,    -1,    84,    -1,    -1,    -1,    -1,
    -1,    90,    -1,    -1,    -1,    94,    -1,    96,    97,    98,
    -1,   100,    72,    73,    74,    75,    76,    -1,    -1,    -1,
    80,    -1,    82,    -1,    84,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    -1,
   100,    72,    73,    74,    75,    76,    -1,    -1,    -1,    80,
    -1,    -1,    -1,    84,    85,    -1,    -1,    -1,    -1,    -1,
    72,    73,    74,    75,    76,    96,    97,    98,    80,   100,
     7,    -1,    84,    -1,    11,    -1,    -1,    -1,    -1,    16,
    -1,    18,    19,    20,    96,    97,    98,    -1,   100,    -1,
    -1,    -1,    -1,    30,    31,    32,    33,    34,    16,    -1,
    -1,    -1,    20,    16,    -1,    -1,    -1,    20,    -1,    -1,
    -1,    -1,    30,    -1,    32,    33,    34,    30,    -1,    32,
    33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    82,    -1,    -1,    -1,    -1,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
    88,    89,    90,    91,    -1,    88,    89,    90,    91
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYPARSE_RETURN_TYPE
#define YYPARSE_RETURN_TYPE int
#endif


#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 222 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
YYPARSE_RETURN_TYPE
yyparse (void *);
#else
YYPARSE_RETURN_TYPE
yyparse (void);
#endif
#endif

YYPARSE_RETURN_TYPE
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
#ifndef YYSTACK_USE_ALLOCA
  int yyfree_stacks = 0;
#endif

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
#ifndef YYSTACK_USE_ALLOCA
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
#endif	    
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 141 "qmparse.y"
{ YYACCEPT; ;
    break;}
case 6:
#line 145 "qmparse.y"
{ if (pmode != INTERACT && pmode != SOURCE)
				  YYERROR; ;
    break;}
case 8:
#line 151 "qmparse.y"
{ shell(); ;
    break;}
case 13:
#line 163 "qmparse.y"
{ if (!expression()) YYABORT; ;
    break;}
case 16:
#line 170 "qmparse.y"
{ if (!copyright()) YYABORT; ;
    break;}
case 17:
#line 173 "qmparse.y"
{
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
#ifdef USE_READLINE
    extern char **sym_completion();
    char **matches = sym_completion(s, 0, strlen(s));
    if (matches) {
      if (matches[0])
	if (!matches[1]) {
	  printf("%s\n", matches[0]);
	  free(matches[0]);
	} else {
	  int i;
	  free(matches[0]);
	  for (i = 1; matches[i]; i++) {
	    printf("%s\n", matches[i]);
	    free(matches[i]);
	  }
	}
      free(matches);
    }
#endif
    free(s);
  } else
    YYABORT;
;
    break;}
case 18:
#line 201 "qmparse.y"
{
  int res = 1;
  if (checkbrk) YYABORT;
  if (gflag)
    gcmd("q-help-cmd");
  else
    res = help(NULL);
  if (!res) YYABORT;
;
    break;}
case 19:
#line 212 "qmparse.y"
{
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    int res = 1;
    if (gflag) gcmd_s("q-help-cmd", s);
    else
      res = help(s);
    free(s);
    if (!res) YYABORT;
  } else
    YYABORT;
;
    break;}
case 20:
#line 226 "qmparse.y"
{
  if (checkbrk) YYABORT;
  printstr(qpath);
;
    break;}
case 21:
#line 232 "qmparse.y"
{
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    if (lt_dlsetsearchpath(qpath)) {
      thr->qmstat = MEM_OVF;
      clean();
      YYABORT;
    }
    if (qpath) free(qpath);
    qpath = s;
    if (gflag) gcmd_s("q-path-cmd", s);
  } else
    YYABORT;
;
    break;}
case 22:
#line 248 "qmparse.y"
{
  if (checkbrk) YYABORT;
  printstr(prompt);
;
    break;}
case 23:
#line 254 "qmparse.y"
{
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    if (prompt) free(prompt);
    prompt = s;
    if (gflag) gcmd_s("q-prompt-cmd", s);
    new_xprompt();
  } else
    YYABORT;
;
    break;}
case 24:
#line 266 "qmparse.y"
{
  if (checkbrk) YYABORT;
  switch (imode) {
  case 0: printf("dec; "); break;
  case 1: printf("hex; "); break;
  case 2: printf("oct; "); break;
  }
  switch (fmode) {
  case 0: printf("std %d\n", fprec); break;
  case 1: printf("sci %d\n", fprec); break;
  case 2: printf("fix %d\n", fprec); break;
  } 
;
    break;}
case 25:
#line 281 "qmparse.y"
{ if (checkbrk) YYABORT; imode = 0; if (gflag) gcmd("q-dec-cmd"); ;
    break;}
case 26:
#line 284 "qmparse.y"
{ if (checkbrk) YYABORT; imode = 1; if (gflag) gcmd("q-hex-cmd"); ;
    break;}
case 27:
#line 287 "qmparse.y"
{ if (checkbrk) YYABORT; imode = 2; if (gflag) gcmd("q-oct-cmd"); ;
    break;}
case 28:
#line 290 "qmparse.y"
{ 
  if (checkbrk) YYABORT;
  fmode = 0; fprec = 15; sprintf(fformat, STDFORMAT, fprec);
  if (gflag) gcmd_i("q-std-cmd", fprec);
;
    break;}
case 29:
#line 297 "qmparse.y"
{
  long p;
  if (intparam(yyvsp[0].sval, &p)) {
    if (p >= 0) {
      fmode = 0; fprec = p; sprintf(fformat, STDFORMAT, fprec);
      if (gflag) gcmd_i("q-std-cmd", fprec);
    } else {
      thr->qmstat = BAD_FORMAT;
      clean();
      YYABORT;
    }
  } else
    YYABORT;
;
    break;}
case 30:
#line 313 "qmparse.y"
{ 
  if (checkbrk) YYABORT;
  fmode = 1; fprec = 15; sprintf(fformat, SCIFORMAT, fprec);
  if (gflag) gcmd_i("q-sci-cmd", fprec);
;
    break;}
case 31:
#line 320 "qmparse.y"
{
  long p;
  if (intparam(yyvsp[0].sval, &p)) {
    if (p >= 0) {
      fmode = 1; fprec = p; sprintf(fformat, SCIFORMAT, fprec);
      if (gflag) gcmd_i("q-sci-cmd", fprec);
    } else {
      thr->qmstat = BAD_FORMAT;
      clean();
      YYABORT;
    }
  } else
    YYABORT;
;
    break;}
case 32:
#line 336 "qmparse.y"
{ 
  if (checkbrk) YYABORT;
  fmode = 2; fprec = 2; sprintf(fformat, FIXFORMAT, fprec);
  if (gflag) gcmd_i("q-fix-cmd", fprec);
;
    break;}
case 33:
#line 343 "qmparse.y"
{
  long p;
  if (intparam(yyvsp[0].sval, &p)) {
    if (p >= 0) {
      fmode = 2; fprec = p; sprintf(fformat, FIXFORMAT, fprec);
      if (gflag) gcmd_i("q-fix-cmd", fprec);
    } else {
      thr->qmstat = BAD_FORMAT;
      clean();
      YYABORT;
    }
  } else
    YYABORT;
;
    break;}
case 34:
#line 359 "qmparse.y"
{
  if (checkbrk) YYABORT;
#ifndef USE_READLINE
  histwarn();
#endif
  printstr(histfile);
;
    break;}
case 35:
#line 368 "qmparse.y"
{
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    sethistfile(s);
    if (gflag) gcmd_s("q-histfile-cmd", s);
  } else
    YYABORT;
;
    break;}
case 36:
#line 378 "qmparse.y"
{
  if (checkbrk) YYABORT;
#ifndef USE_READLINE
  histwarn();
#endif
  printf("%d\n", histmax);
;
    break;}
case 37:
#line 387 "qmparse.y"
{
  long i;
  if (intparam(yyvsp[0].sval, &i)) {
    sethistsize(i);
    if (gflag) gcmd_i("q-histsize-cmd", i);
  } else
    YYABORT;
;
    break;}
case 38:
#line 397 "qmparse.y"
{
  if (checkbrk) YYABORT;
  printf("%d\n", stackmax);
;
    break;}
case 39:
#line 403 "qmparse.y"
{
  long i;
  if (intparam(yyvsp[0].sval, &i)) {
    if (i == 0 || i >= STACKMIN) {
      stackmax = i;
    } else {
      printf("bad stack size %d, using default\n", i);
      stackmax = STACKMAX;
    }
    if (gflag) gcmd_i("q-stacksize-cmd", stackmax);
    /* this is needed to have the stack resized properly */
    clean();
  } else
    YYABORT;
;
    break;}
case 40:
#line 420 "qmparse.y"
{
  if (checkbrk) YYABORT;
  printf("%d\n", memmax);
;
    break;}
case 41:
#line 426 "qmparse.y"
{
  long i;
  if (intparam(yyvsp[0].sval, &i)) {
    if (i == 0 || i >= MEMMIN) {
      memmax = i;
    } else {
      printf("bad memory size %d, using default\n", i);
      memmax = MEMMAX;
    }
    lastblksz = memmax % XBLKSZ;
    maxnblks = memmax/XBLKSZ+((memmax <= 0||lastblksz==0)?0:1);
    if (lastblksz == 0) lastblksz = XBLKSZ;
    if (gflag) gcmd_i("q-memsize-cmd", memmax);
  } else
    YYABORT;
;
    break;}
case 42:
#line 444 "qmparse.y"
{ if (checkbrk) YYABORT; print_stats(); ;
    break;}
case 43:
#line 447 "qmparse.y"
{
  char wd[MAXSTRLEN];
  if (checkbrk) YYABORT;
  if (getcwd(wd, MAXSTRLEN)) {
    printstr(wd);
  } else {
    thr->qmstat = MEM_OVF;
    clean();
    YYABORT;
  }
;
    break;}
case 44:
#line 460 "qmparse.y"
{
  char buf[MAXSTRLEN];
  if (checkbrk) YYABORT;
  if (chdir(expand(buf, "~"))) {
    thr->qmstat = BAD_DIR;
    clean();
    YYABORT;
  } else {
    if (gflag) gcmd_s("q-cd-cmd", buf);
    new_xprompt();
  }
;
    break;}
case 45:
#line 474 "qmparse.y"
{
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    int res;
    char *buf =
      malloc((MAXSTRLEN+strlen(s)+1)*
	     sizeof(char));
    if (buf)
      expand(buf, s);
    else
      thr->qmstat = MEM_OVF;
    free(s);
    res = clean();
    if (res && buf)
      if (chdir(buf)) {
	thr->qmstat = BAD_DIR;
	res = clean();
      } else {
	if (gflag) gcmd_s("q-cd-cmd", buf);
	new_xprompt();
      }
    if (buf) free(buf);
    if (!res) YYABORT;
  } else
    YYABORT;
;
    break;}
case 46:
#line 503 "qmparse.y"
{
  static char ls_cmd[] = "ls";
  char **argv = yyvsp[0].aval.v, *cmd;
  int argc = yyvsp[0].aval.c, l = 0, i;
  for (i = 0; i < argc; i++)
    l += strlen(argv[i])+1;
  if (!(cmd = (char*)malloc((strlen(ls_cmd)+l+1)*sizeof(char))))
    thr->qmstat = MEM_OVF;
  else {
    strcpy(cmd, ls_cmd);
    for (i = 0; i < argc; i++)
      strcat(strcat(cmd, " "), argv[i]);
    push_sigint(SIG_DFL);
    system(cmd);
    pop_sigint();
    free(cmd);
  }
  for (i = 0; i < argc; i++) free(argv[i]);
  free(argv);
  if (!clean()) YYABORT;
;
    break;}
case 47:
#line 526 "qmparse.y"
{
  if (checkbrk) YYABORT;
  printf("debug is %s\n", debug?"on":"off");
;
    break;}
case 48:
#line 532 "qmparse.y"
{
  int b;
  if (boolparam(yyvsp[0].sval, &b)) {
    debug = thr->debug = b;
    if (gflag) gcmd_b("q-debug-cmd", b);
  } else
    YYABORT;
;
    break;}
case 49:
#line 542 "qmparse.y"
{
  if (checkbrk) YYABORT;
  printf("break is %s\n", brkdbg?"on":"off");
;
    break;}
case 50:
#line 548 "qmparse.y"
{
  int b;
  if (boolparam(yyvsp[0].sval, &b)) {
    brkdbg = b;
    if (gflag) gcmd_b("q-break-cmd", b);
  } else
    YYABORT;
;
    break;}
case 51:
#line 558 "qmparse.y"
{
  if (checkbrk) YYABORT;
  printf("echo is %s\n", eflag?"on":"off");
;
    break;}
case 52:
#line 564 "qmparse.y"
{
  int b; char *s;
  if (boolstrparam(yyvsp[0].sval, &b, &s))
    if (!s) {
      eflag = b;
      if (gflag) gcmd_b("q-echo-cmd", b);
    } else {
      printf("%s\n", s);
      free(s);
    }
  else
    YYABORT;
;
    break;}
case 53:
#line 579 "qmparse.y"
{
  if (checkbrk) YYABORT;
  printstr(which);
;
    break;}
case 54:
#line 585 "qmparse.y"
{
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    int l0 = strlen(s), l = strlen(qpath)+l0;
    char *buf = malloc((l+3)*sizeof(char));
    char *name = malloc((l+MAXSTRLEN+3)*sizeof(char));
    if (buf && name) {
      absname(name, searchlib(buf, s));
      if (!chkfile(name)) {
	char *t = malloc((l0+3)*sizeof(char));
	if (!t) goto errexit;
	strcat(strcpy(t, s), ".q");
	absname(name, searchlib(buf, t));
	free(t);
      }
      if (chkfile(name))
	printstr(name);
      else
	printf("%s not found\n", s);
    } else {
    errexit:
      thr->qmstat = MEM_OVF;
    }
    clean();
    free(s);
    if (buf) free(buf);
    if (name) free(name);
  } else
    YYABORT;
;
    break;}
case 55:
#line 617 "qmparse.y"
{
  if (checkbrk) YYABORT;
  if (gflag)
    gcmd_s("q-edit-cmd", which);
  else if (!edit(which))
    YYABORT;
;
    break;}
case 56:
#line 626 "qmparse.y"
{
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    int res;
    char *buf = malloc((MAXSTRLEN+strlen(s)+1)*sizeof(char));
    if (buf) {
      expand(buf, s);
      if (gflag)
	gcmd_s("q-edit-cmd", buf);
      else
	edit(buf);
    } else
      thr->qmstat = MEM_OVF;
    res = clean();
    free(s); if (buf) free(buf);
    if (!res) YYABORT;
  } else
    YYABORT;
;
    break;}
case 57:
#line 647 "qmparse.y"
{
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    int l = strlen(qpath)+strlen(s);
    char *buf = malloc((l+1)*sizeof(char));
    if (buf) {
      int res = parsesrc(searchlib(buf, s), 1);
      if (!res) {
	free(buf);
	free(s);
	YYABORT;
      }
    } else
      thr->qmstat = MEM_OVF;
    free(s);
    if (buf) free(buf);
    if (!clean())
      YYABORT;
  } else
    YYABORT;
;
    break;}
case 58:
#line 670 "qmparse.y"
{
  if (checkbrk) YYABORT;
  if (!save_file)
    save_file = strdup("q_vars");
  if (!save_file) {
    thr->qmstat = MEM_OVF;
    clean();
    YYABORT;
  }
  if (chkfile(save_file)) {
    printf("loading ");
    printstr(save_file);
    if (!parsesrc(save_file, 0)) YYABORT;
  }
;
    break;}
case 59:
#line 687 "qmparse.y"
{
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    char *buf = malloc((strlen(s)+MAXSTRLEN+1)*sizeof(char));
    if (buf) {
      int res = parsesrc(expand(buf, s), 0);
      if (res) {
	if (save_file) free(save_file);
	save_file = buf;
      } else {
	free(buf);
	free(s);
	YYABORT;
      }
    } else
      thr->qmstat = MEM_OVF;
    free(s);
    if (!clean())
      YYABORT;
  } else
    YYABORT;
;
    break;}
case 60:
#line 711 "qmparse.y"
{
  if (checkbrk) YYABORT;
  if (!save_file)
    save_file = strdup("q_vars");
  if (!save_file) {
    thr->qmstat = MEM_OVF;
    clean();
    YYABORT;
  }
  printf("saving ");
  printstr(save_file);
  if (!save_vars(NULL)) YYABORT;
;
    break;}
case 61:
#line 726 "qmparse.y"
{
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    int res;
    char *buf = malloc((strlen(s)+MAXSTRLEN+1)*sizeof(char));
    if (buf) {
      res = save_vars(expand(buf, s));
      if (!res)	free(buf);
    } else {
      thr->qmstat = MEM_OVF;
      res = 0;
    }
    free(s);
    if (!res) YYABORT;
  } else
    YYABORT;
;
    break;}
case 62:
#line 745 "qmparse.y"
{ if (checkbrk) YYABORT; clear_vars(); ;
    break;}
case 64:
#line 750 "qmparse.y"
{
  char **argv = yyvsp[0].aval.v;
  int count = 0, i, argc = yyvsp[0].aval.c;
  if (argv && argc > 0) {
    for (i = 0; i < argc; i++) {
      int res;
      if (*argv[i] == '-')
	res = del_import(argv[i]+1);
      else if (*argv[i] == '+')
	res = add_import(strdup(argv[i]+1));
      else
	res = add_import(strdup(argv[i]));
      if (res) count++;
      free(argv[i]);
    }
    free(argv);
    if (count)
      rerun(0, NULL);
  } else if (clear_imports())
    rerun(0, NULL);
;
    break;}
case 65:
#line 773 "qmparse.y"
{ if (!import_list()) YYABORT; ;
    break;}
case 66:
#line 776 "qmparse.y"
{ if (!modules()) YYABORT; ;
    break;}
case 67:
#line 779 "qmparse.y"
{ if (!who()) YYABORT; ;
    break;}
case 69:
#line 784 "qmparse.y"
{ if (checkbrk) YYABORT; rerun(0, NULL); ;
    break;}
case 70:
#line 787 "qmparse.y"
{
  char *s;
  if (strparam(yyvsp[0].sval, &s)) {
    yyval.aval.v = (char**)malloc((MAXARGC+1)*sizeof(char*));
    if (!yyval.aval.v) {
      thr->qmstat = MEM_OVF;
      clean();
      YYABORT;
    }
    yyval.aval.v[0] = s;
    yyval.aval.c = 1;
  } else
    YYABORT;
;
    break;}
case 71:
#line 802 "qmparse.y"
{
  char **argv = yyvsp[0].aval.v;
  int argc = yyvsp[0].aval.c;
  argv[argc] = NULL;
  if (!rerun(argc, argv)) {
    while (argc > 0)
      if (argv[argc-1]) free(argv[--argc]);
    if (argv) free(argv);
    YYABORT;
  }
;
    break;}
case 74:
#line 817 "qmparse.y"
{ if (!unassignment(yyvsp[0].ival)) YYABORT; ;
    break;}
case 77:
#line 821 "qmparse.y"
{ if (checkbrk) YYABORT; whos(yyvsp[0].ival); ;
    break;}
case 79:
#line 823 "qmparse.y"
{ yyval.ival = yyvsp[-1].ival; ;
    break;}
case 80:
#line 828 "qmparse.y"
{
  yyval.aval = yyvsp[0].aval;
;
    break;}
case 81:
#line 834 "qmparse.y"
{
  char *s;
  if (yyvsp[-1].aval.c >= MAXARGC) {
    thr->qmstat = ARGS_ERR;
    while (yyvsp[-1].aval.c > 0)
      free(yyvsp[-1].aval.v[--yyvsp[-1].aval.c]);
    free(yyvsp[-1].aval.v);
    clean();
    YYABORT;
  } else if (strparam(yyvsp[0].sval, &s))
    yyvsp[-1].aval.v[yyvsp[-1].aval.c++] = s;
  else {
    while (yyvsp[-1].aval.c > 0)
      free(yyvsp[-1].aval.v[--yyvsp[-1].aval.c]);
    free(yyvsp[-1].aval.v);
    YYABORT;
  }
  yyval.aval = yyvsp[-1].aval;
;
    break;}
case 82:
#line 858 "qmparse.y"
{
  if (checkbrk) YYABORT;
  yyval.aval.v = (char**)malloc((MAXARGC+1)*sizeof(char*));
  if (!yyval.aval.v) {
    thr->qmstat = MEM_OVF;
    clean();
    YYABORT;
  }
  yyval.aval.c = 0;
;
    break;}
case 83:
#line 871 "qmparse.y"
{
  char *s;
  if (yyvsp[-1].aval.c >= MAXARGC) {
    thr->qmstat = ARGS_ERR;
    while (yyvsp[-1].aval.c > 0)
      free(yyvsp[-1].aval.v[--yyvsp[-1].aval.c]);
    free(yyvsp[-1].aval.v);
    clean();
    YYABORT;
  } else if (strparam(yyvsp[0].sval, &s))
    yyvsp[-1].aval.v[yyvsp[-1].aval.c++] = s;
  else {
    while (yyvsp[-1].aval.c > 0)
      free(yyvsp[-1].aval.v[--yyvsp[-1].aval.c]);
    free(yyvsp[-1].aval.v);
    YYABORT;
  }
  yyval.aval = yyvsp[-1].aval;
;
    break;}
case 85:
#line 894 "qmparse.y"
{ YYERROR; ;
    break;}
case 88:
#line 902 "qmparse.y"
{ if (!assignment()) YYABORT; ;
    break;}
case 91:
#line 910 "qmparse.y"
{ if (!unassignment(yyvsp[0].ival)) YYABORT; ;
    break;}
case 93:
#line 915 "qmparse.y"
{ if (!pushbin(SEQOP)) YYABORT; ;
    break;}
case 95:
#line 920 "qmparse.y"
{ if (!pushbin(yyvsp[-1].ival)) YYABORT; ;
    break;}
case 96:
#line 923 "qmparse.y"
{ yyval.ival = LEOP; ;
    break;}
case 97:
#line 924 "qmparse.y"
{ yyval.ival = GROP; ;
    break;}
case 98:
#line 925 "qmparse.y"
{ yyval.ival = LEQOP; ;
    break;}
case 99:
#line 926 "qmparse.y"
{ yyval.ival = GEQOP; ;
    break;}
case 100:
#line 927 "qmparse.y"
{ yyval.ival = NEQOP; ;
    break;}
case 101:
#line 928 "qmparse.y"
{ yyval.ival = INOP; ;
    break;}
case 103:
#line 933 "qmparse.y"
{ if (!pushbin(SEQOP)) YYABORT; ;
    break;}
case 105:
#line 938 "qmparse.y"
{ if (!pushbin(yyvsp[-1].ival)) YYABORT; ;
    break;}
case 106:
#line 941 "qmparse.y"
{ yyval.ival = LEOP; ;
    break;}
case 107:
#line 942 "qmparse.y"
{ yyval.ival = GROP; ;
    break;}
case 108:
#line 943 "qmparse.y"
{ yyval.ival = EQOP; ;
    break;}
case 109:
#line 944 "qmparse.y"
{ yyval.ival = LEQOP; ;
    break;}
case 110:
#line 945 "qmparse.y"
{ yyval.ival = GEQOP; ;
    break;}
case 111:
#line 946 "qmparse.y"
{ yyval.ival = NEQOP; ;
    break;}
case 112:
#line 947 "qmparse.y"
{ yyval.ival = INOP; ;
    break;}
case 114:
#line 952 "qmparse.y"
{ if (!pushbin(yyvsp[-1].ival)) YYABORT; ;
    break;}
case 115:
#line 954 "qmparse.y"
{ if (!pushbin(MINOP)) YYABORT; ;
    break;}
case 116:
#line 957 "qmparse.y"
{ yyval.ival = ADDOP; ;
    break;}
case 117:
#line 958 "qmparse.y"
{ yyval.ival = CATOP; ;
    break;}
case 118:
#line 959 "qmparse.y"
{ yyval.ival = OROP; ;
    break;}
case 119:
#line 960 "qmparse.y"
{ yyval.ival = ORELSEOP; ;
    break;}
case 121:
#line 965 "qmparse.y"
{ if (!pushbin(yyvsp[-1].ival)) YYABORT; ;
    break;}
case 122:
#line 968 "qmparse.y"
{ yyval.ival = MULOP; ;
    break;}
case 123:
#line 969 "qmparse.y"
{ yyval.ival = FDIVOP; ;
    break;}
case 124:
#line 970 "qmparse.y"
{ yyval.ival = DIVOP; ;
    break;}
case 125:
#line 971 "qmparse.y"
{ yyval.ival = MODOP; ;
    break;}
case 126:
#line 972 "qmparse.y"
{ yyval.ival = ANDOP; ;
    break;}
case 127:
#line 973 "qmparse.y"
{ yyval.ival = ANDTHENOP; ;
    break;}
case 129:
#line 979 "qmparse.y"
{ mpz_neg(yyvsp[0].zval, yyvsp[0].zval);
		                  if (!pushmpz(thr, yyvsp[0].zval)) YYABORT; ;
    break;}
case 130:
#line 981 "qmparse.y"
{ if (!pushfloat(thr, -yyvsp[0].fval)) YYABORT; ;
    break;}
case 131:
#line 982 "qmparse.y"
{ if (!pushun(UMINOP)) YYABORT; ;
    break;}
case 132:
#line 983 "qmparse.y"
{ if (!pushun(yyvsp[-1].ival)) YYABORT; ;
    break;}
case 133:
#line 986 "qmparse.y"
{ yyval.ival = HASHOP; ;
    break;}
case 134:
#line 987 "qmparse.y"
{ yyval.ival = NOTOP; ;
    break;}
case 136:
#line 992 "qmparse.y"
{ if (!pushbin(yyvsp[-1].ival)) YYABORT; ;
    break;}
case 137:
#line 995 "qmparse.y"
{ yyval.ival = POWOP; ;
    break;}
case 138:
#line 996 "qmparse.y"
{ yyval.ival = IDXOP; ;
    break;}
case 140:
#line 1001 "qmparse.y"
{ if (!pushfun(thr, APPOP)) YYABORT; ;
    break;}
case 141:
#line 1004 "qmparse.y"
{ yyval.ival = QUOTEOP; ;
    break;}
case 142:
#line 1005 "qmparse.y"
{ yyval.ival = UNQUOTEOP; ;
    break;}
case 143:
#line 1006 "qmparse.y"
{ yyval.ival = FORCEOP; ;
    break;}
case 144:
#line 1012 "qmparse.y"
{ if (!pushmpz(thr, yyvsp[0].zval)) YYABORT; ;
    break;}
case 145:
#line 1013 "qmparse.y"
{ if (!pushfloat(thr, yyvsp[0].fval)) YYABORT; ;
    break;}
case 146:
#line 1014 "qmparse.y"
{ if (!pushstr(thr, yyvsp[0].sval)) YYABORT; ;
    break;}
case 147:
#line 1015 "qmparse.y"
{ YYERROR; ;
    break;}
case 148:
#line 1019 "qmparse.y"
{ if (yyvsp[0].ival == NONE) { YYABORT; }
				  else if (!pushfun(thr, yyvsp[0].ival)) YYABORT; ;
    break;}
case 149:
#line 1021 "qmparse.y"
{ if (!pushfun(thr, yyvsp[-1].ival)) YYABORT; ;
    break;}
case 150:
#line 1025 "qmparse.y"
{ thr->qmstat = BAD_OBJ; YYABORT; ;
    break;}
case 151:
#line 1030 "qmparse.y"
{ if (!pushun(yyvsp[-1].ival)) YYABORT; ;
    break;}
case 152:
#line 1035 "qmparse.y"
{ if (!pushun(SEQOP)) YYABORT; ;
    break;}
case 153:
#line 1038 "qmparse.y"
{ if (!(pushfun(thr, FLIPOP) && pushfun(thr, SEQOP) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; ;
    break;}
case 154:
#line 1043 "qmparse.y"
{ if (!pushun(yyvsp[-1].ival)) YYABORT; ;
    break;}
case 155:
#line 1046 "qmparse.y"
{ if (!(pushfun(thr, FLIPOP) && pushfun(thr, yyvsp[-2].ival) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; ;
    break;}
case 156:
#line 1051 "qmparse.y"
{ if (!pushun(yyvsp[-1].ival)) YYABORT; ;
    break;}
case 157:
#line 1054 "qmparse.y"
{ if (!pushun(MINOP)) YYABORT; ;
    break;}
case 158:
#line 1057 "qmparse.y"
{ if (!(pushfun(thr, FLIPOP) && pushfun(thr, yyvsp[-2].ival) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; ;
    break;}
case 159:
#line 1062 "qmparse.y"
{ if (!pushun(yyvsp[-1].ival)) YYABORT; ;
    break;}
case 160:
#line 1065 "qmparse.y"
{ if (!(pushfun(thr, FLIPOP) && pushfun(thr, yyvsp[-2].ival) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; ;
    break;}
case 161:
#line 1070 "qmparse.y"
{ if (!pushun(yyvsp[-1].ival)) YYABORT; ;
    break;}
case 162:
#line 1073 "qmparse.y"
{ if (!(pushfun(thr, FLIPOP) && pushfun(thr, yyvsp[-2].ival) &&
					pushfun(thr, APPOP) && swap() &&
					pushfun(thr, APPOP))) YYABORT; ;
    break;}
case 163:
#line 1080 "qmparse.y"
{ if (!pushfun(thr, VOIDOP)) YYABORT; ;
    break;}
case 164:
#line 1082 "qmparse.y"
{ if (!pushfun(thr, VOIDOP) ||
				      !pushfun(thr, PAIROP)) YYABORT; ;
    break;}
case 166:
#line 1086 "qmparse.y"
{ if (!pushfun(thr, PAIROP)) YYABORT; ;
    break;}
case 167:
#line 1088 "qmparse.y"
{ if (!pushfun(thr, PAIROP)) YYABORT; ;
    break;}
case 168:
#line 1094 "qmparse.y"
{ if (!pushfun(thr, NILOP)) YYABORT; ;
    break;}
case 170:
#line 1099 "qmparse.y"
{ YYABORT; ;
    break;}
case 171:
#line 1104 "qmparse.y"
{ if (!pushfun(thr, VOIDOP) ||
				     !pushfun(thr, PAIROP)) YYABORT; ;
    break;}
case 172:
#line 1107 "qmparse.y"
{ if (!pushfun(thr, PAIROP)) YYABORT; ;
    break;}
case 173:
#line 1109 "qmparse.y"
{ if (!pushfun(thr, PAIROP)) YYABORT; ;
    break;}
case 174:
#line 1113 "qmparse.y"
{ if (!pushfun(thr, NILOP) ||
				     !pushfun(thr, CONSOP)) YYABORT; ;
    break;}
case 175:
#line 1116 "qmparse.y"
{ if (!pushfun(thr, CONSOP)) YYABORT; ;
    break;}
case 176:
#line 1118 "qmparse.y"
{ if (!pushfun(thr, CONSOP)) YYABORT; ;
    break;}
case 177:
#line 1121 "qmparse.y"
{ yyval.ival = SEQOP; ;
    break;}
case 178:
#line 1122 "qmparse.y"
{ yyval.ival = LEOP; ;
    break;}
case 179:
#line 1123 "qmparse.y"
{ yyval.ival = GROP; ;
    break;}
case 180:
#line 1124 "qmparse.y"
{ yyval.ival = EQOP; ;
    break;}
case 181:
#line 1125 "qmparse.y"
{ yyval.ival = LEQOP; ;
    break;}
case 182:
#line 1126 "qmparse.y"
{ yyval.ival = GEQOP; ;
    break;}
case 183:
#line 1127 "qmparse.y"
{ yyval.ival = NEQOP; ;
    break;}
case 184:
#line 1128 "qmparse.y"
{ yyval.ival = INOP; ;
    break;}
case 185:
#line 1129 "qmparse.y"
{ yyval.ival = CATOP; ;
    break;}
case 186:
#line 1130 "qmparse.y"
{ yyval.ival = ADDOP; ;
    break;}
case 187:
#line 1131 "qmparse.y"
{ yyval.ival = MINOP; ;
    break;}
case 188:
#line 1132 "qmparse.y"
{ yyval.ival = OROP; ;
    break;}
case 189:
#line 1133 "qmparse.y"
{ yyval.ival = ORELSEOP; ;
    break;}
case 190:
#line 1134 "qmparse.y"
{ yyval.ival = MULOP; ;
    break;}
case 191:
#line 1135 "qmparse.y"
{ yyval.ival = FDIVOP; ;
    break;}
case 192:
#line 1136 "qmparse.y"
{ yyval.ival = DIVOP; ;
    break;}
case 193:
#line 1137 "qmparse.y"
{ yyval.ival = MODOP; ;
    break;}
case 194:
#line 1138 "qmparse.y"
{ yyval.ival = ANDOP; ;
    break;}
case 195:
#line 1139 "qmparse.y"
{ yyval.ival = ANDTHENOP; ;
    break;}
case 196:
#line 1140 "qmparse.y"
{ yyval.ival = HASHOP; ;
    break;}
case 197:
#line 1141 "qmparse.y"
{ yyval.ival = NOTOP; ;
    break;}
case 198:
#line 1142 "qmparse.y"
{ yyval.ival = QUOTEOP; ;
    break;}
case 199:
#line 1143 "qmparse.y"
{ yyval.ival = UNQUOTEOP; ;
    break;}
case 200:
#line 1144 "qmparse.y"
{ yyval.ival = FORCEOP; ;
    break;}
case 201:
#line 1145 "qmparse.y"
{ yyval.ival = POWOP; ;
    break;}
case 202:
#line 1146 "qmparse.y"
{ yyval.ival = IDXOP; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 554 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
#ifndef YYSTACK_USE_ALLOCA
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
#endif
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
#ifndef YYSTACK_USE_ALLOCA
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
#endif    
  return 1;
}
#line 1149 "qmparse.y"


yyerror(s)
	char           *s;
{
  if (thr->qmstat == OK && (thr > thr0 || !checkbrk) &&
      strcmp(s, "parse error") == 0)
    thr->qmstat = SYNTAX_ERR;
}

/* routines to construct expressions: */

static swap()
	/* swap the topmost two stack elements */
{
  EXPR		*x;

  x = thr->xsp[-2]; thr->xsp[-2] = thr->xsp[-1]; thr->xsp[-1] = x;
  return (1);
}

static pushbin(fno)
     /* process binary op */
     int		fno;
{
  return (swap() && pushfun(thr, fno) && swap() && pushfun(thr, APPOP) &&
	  swap() && pushfun(thr, APPOP));
}

static pushun(fno)
	/* process unary op */
     int		fno;
{
  return (pushfun(thr, fno) && swap() && pushfun(thr, APPOP));
}

/* eval stats */

static init_stats()
{
  thr0->stats_init = 1;
  thr0->stats_fini = 0;
  thr0->nredns = thr0->nexprs = thr0->maxexprs = 0;
  thr0->starttime = clock();
  return 1;
}

static fini_stats()
{
  thr0->endtime = clock();
  thr0->stats_fini = 1;
  return 1;
}

static print_stats()
{
  for (thr = thr0; thr < thr0+nthreads; thr++)
    if (thr->used && (thr == thr0 || !thr->active) && thr->stats_init) {
      if (!thr->stats_fini ||
	  thr->starttime == (clock_t)-1 ||
	  thr->endtime == (clock_t)-1)
	if (thr > thr0)
	  printf("thread #%d: %lu reduction%s, %lu cell%s\n",
		 thr-thr0,
		 thr->nredns, thr->nredns!=1?"s":"",
		 thr->maxexprs, thr->maxexprs!=1?"s":"");
	else
	  printf("%lu reduction%s, %lu cell%s\n",
		 thr->nredns, thr->nredns!=1?"s":"",
		 thr->maxexprs, thr->maxexprs!=1?"s":"");
      else
	if (thr > thr0)
	  printf("thread #%d: %0.3g secs, %lu reduction%s, %lu cell%s\n",
		 thr-thr0,
		 ((double)(thr->endtime-thr->starttime))/(double)CLOCKS_PER_SEC,
		 thr->nredns, thr->nredns!=1?"s":"",
		 thr->maxexprs, thr->maxexprs!=1?"s":"");
	else
	  printf("%0.3g secs, %lu reduction%s, %lu cell%s\n",
		 ((double)(thr->endtime-thr->starttime))/(double)CLOCKS_PER_SEC,
		 thr->nredns, thr->nredns!=1?"s":"",
		 thr->maxexprs, thr->maxexprs!=1?"s":"");
  }
}

/* parse actions: */

extern char *actchar();

static error_report(base, p, tok)
     char *base, *p, *tok;
{
  char *q = p, *r =strchr(p, '\n'), *s, *t, c;
  int l = strlen(tok);
  while (q > base && q[-1] != '\n') --q;
  if (r) c = *r, *r = 0;
  if (tok && *tok && p-q >= l)
    if (strncmp(p-l, tok, l) == 0)
      p -= l;
    else if (p-q >= l+1 && strncmp(p-l-1, tok, l) == 0)
      /* token may actually be off one to the left because of lookahead */
      p -= l+1;
/*     else */
      /* token not found; assume it's the character to the left of the
	 current position */
/*       --p; */
  else
    --p;
  if (tok && strcmp(tok, "\"") == 0 && *p == '"') {
    /* it's a string token, try to back up to the beginning of the string */
    while (p > q && (p[-1] != '"' || p > q+1 && p[-2] == '\\')) --p;
    if (p > q && p[-1] == '"') --p;
  }
  if (p < q) p = q;
  s = malloc((p-q+2)*sizeof(char));
  if (!s) fatal("memory overflow");
  strncpy(s, q, p-q+1);
  s[p-q+1] = 0;
  for (t = s; *t; t++)
    if (!isspace(*t))
      *t = ' ';
  s[p-q] = '^';
  printf(">>> %s\n", q);
  printf("    %s\n", s);
  if (r) *r = c;
  free(s);
}

DECLARE_YYTEXT

static char *tok = NULL, *p = NULL;;
static int toksz = 0;

static savepos()
{
  int l = strlen(yytext);
  p = actchar();
  if (l < 1000) l = 1000;
  if (!tok)
    tok = malloc((toksz = l+1)*sizeof(char));
  else if (toksz < l+1)
    tok = realloc(tok, (toksz = l+1)*sizeof(char));
  if (!tok)
    fatal("memory overflow");
  strcpy(tok, yytext);
}

extern int actlineno;

static clean()
{
  THREAD *thr = get_thr();
  int res = !(thr->qmstat != OK && thr->qmstat != HALT && thr->qmstat != QUIT);
  if (ferror(stdin))
    clearerr(stdin);
  if (!res) {
    if (pmode == SOURCE) {
      char msg[MAXSTRLEN];
      sprintf(msg, "File %s, line %d: %s", psource, actlineno,
	      qmmsg[thr->qmstat]);
      error(msg);
    } else
      error(qmmsg[thr->qmstat]);
    if (thr->qmstat == XCEPT && thr->xsp > thr->xst) {
      printx(thr->xsp[-1]); printf("\n");
    }
    if ((pmode == INTERACT || pmode == SOURCE) && base && p)
      error_report(base, p, tok);
  }
  if (!quitflag && thr->qmstat != QUIT)
    clear(0);
  thr->debug = debug;
  thr->mode = 1;
  return res && !checkbrk;
}

static expression()
{
  if (!checkbrk && init_stats() && eval(thr, thr->xsp[-1]) && fini_stats() &&
      !checkbrk) {
    printx(thr->xsp[-1]);
    putchar('\n');
    if (thr->xsp[-1]->fno != DEFVAROP)
      setvar(DEFVAROP, thr->xsp[-1]);
  } else if (!checkbrk)
    fini_stats();
  savepos();
  return clean();
}

static assignment()
{
  if (!checkbrk && init_stats() && eval(thr, thr->xsp[-1])) {
    thr->nredns++;
    thr->args[0] = thr->xsp[-3];
    thr->args[1] = thr->xsp[-1];
    (*funtb[DEFOP])(thr);
    fini_stats();
  }
  savepos();
  return clean();
}

static unassignment(int id)
{
  if (symtb[id].x)
    setvar(id, NULL);
  savepos();
  return clean();
}

/* built-in commands: */

static printstr(s)
     char *s;
{
  printf("%s\n", s);
}

static strparam(a, s)
     char *a, **s;
{
  *s = NULL;
  if (!checkbrk && !(*s = strdup(a)))
    thr->qmstat = MEM_OVF;
  savepos();
  if (clean())
    return *s != NULL;
  else {
    if (*s) free(*s);
    return 0;
  }
}

static intparam(a, i)
     char *a; long *i;
{
  int res = !checkbrk;
  if (res) {
    char *s = a;
    while (isdigit(*s)) s++;
    if (!*s) {
      res = 1;
      *i = atol(a);
    } else
      thr->qmstat = BAD_INTVAL;
  }
  savepos();
  return clean() && res;
}

static boolparam(a, b)
     char *a; int *b;
{
  int res = !checkbrk;
  if (res)
    if (!strcmp(a, "on"))
      *b = 1;
    else if (!strcmp(a, "off"))
      *b = 0;
    else {
      res = 0;
      thr->qmstat = BAD_BOOLVAL;
    }
  savepos();
  return clean() && res;
}

static boolstrparam(a, b, s)
     char *a; int *b; char **s;
{
  int res = !checkbrk;
  *s = NULL;
  if (res)
    if (!strcmp(a, "on"))
      *b = 1;
    else if (!strcmp(a, "off"))
      *b = 0;
    else
      return strparam(a, s);
  savepos();
  return clean() && res;
}

static copyright()
{
  if (!checkbrk) {
    printf("\n");
    printf(signon, version, sysinfo, year);
    printf(copying);
  }
  savepos();
  return clean();
}

static shell()
{
  if (!checkbrk) {
    char shell_command[MAXSTRLEN];
    getln(shell_command);
    push_sigint(SIG_DFL);
    system(shell_command);
    pop_sigint();
  }
  savepos();
  return clean();
}

#ifdef USE_READLINE
extern int use_readline;
#else
static histwarn()
{
  static done = 0;
  if (done)
    return;
  else if (gflag || !iflag || !isatty(fileno(stdin)))
    done = 1;
  else {
    error("Warning: history not supported");
    done = 1;
  }
}
#endif

static sethistfile(s)
     char *s;
{
#ifdef USE_READLINE
  if (!gflag && use_readline && histmax > 0) {
    char h[MAXSTRLEN];
    write_history(expand(h, histfile));
  }
#else
  histwarn();
#endif
  if (histfile) free(histfile);
  histfile = s;
#ifdef USE_READLINE
  if (!gflag && use_readline) {
    char h[MAXSTRLEN];
    clear_history();
    if (histmax > 0)
      read_history(expand(h, histfile));
    stifle_history(histmax);
  }
#endif
}

static sethistsize(i)
     int i;
{
  histmax = i>=0?i:0;
#ifdef USE_READLINE
  if (!gflag && use_readline)
    stifle_history(histmax);
#else
  histwarn();
#endif
}

static help(s)
     char *s;
{
  static char *info = NULL;
  char *cmd;
  if (!info && !(info = getenv("INFO_PROGRAM")))
    info = "info";
  if ((cmd = malloc(((s?strlen(s):0)+strlen(info)+MAXSTRLEN)*sizeof(char)))) {
    if (s)
      sprintf(cmd, "%s -f qdoc --index-search %s", info, s);
    else
      sprintf(cmd, "%s -f qdoc", info);
    push_sigint(SIG_DFL);
    system(cmd);
    pop_sigint();
    free(cmd);
  } else
    thr->qmstat = MEM_OVF;
  return clean();
}

static edit(s)
     char *s;
{
  static char *editor = NULL;
  char *cmd;
  if (!editor && !(editor = getenv("EDITOR")))
    editor = "vi";
  if ((cmd = malloc((strlen(s)+strlen(editor)+4)*sizeof(char)))) {
    if (s && *s)
      sprintf(cmd, "%s \"%s\"", editor, s);
    else
      sprintf(cmd, "%s %s", editor, s?s:"");
    push_sigint(SIG_DFL);
    system(cmd);
    pop_sigint();
    free(cmd);
  } else
    thr->qmstat = MEM_OVF;
}

static save_vars(s)
     char *s;
{
  FILE	       *fp;
  int		res = 0, i;
  char         *s_bak = save_file, _fformat[30];

  strcpy(_fformat, fformat);
  sprintf(fformat, STDFORMAT, 15);
  if (!s) {
    if (!save_file) save_file = strdup("q_vars");
    if (!save_file) {
      error(qmmsg[MEM_OVF]);
      strcpy(fformat, _fformat);
      return 0;
    }
    s = save_file;
  } else
    save_file = s;
  if ((fp = fopen(s, "w"))) {
    /* store variable definitions: */
    for (i = symtbsz; i<symtbsz+tmptbsz; i++)
      if (symtb[i].x && i != DEFVAROP) {
	char str[MAXSTRLEN];
	fprintf(fp, "def %s = ", pname(str, i));
	fprintx(fp, symtb[i].x);
	putc('\n', fp);
      }
    res = !ferror(fp);
    fclose(fp);
  }
  if (!res) {
    char msg[MAXSTRLEN];
    sprintf(msg, qmmsg[FILE_ERR], s);
    error(msg);
    if (save_file && s_bak != save_file) free(save_file);
    save_file = s_bak;
  } else if (s_bak && s_bak != save_file)
    free(s_bak);
  strcpy(fformat, _fformat);
  return res;
}

static clear_vars()
{
  int		i;
  
  /* clear variable definitions: */

  for (i = symtbsz; i<symtbsz+tmptbsz; i++)
    if (symtb[i].x)
      setvar(i, NULL);
  clear(0);
}

int aximpsz = 0, ximpsz = 0;
char **ximp = NULL;

static
search_import(m)
     char *m;
{
  int i;
  char modname[MAXSTRLEN];
  for (i = 0; i < ximpsz; i++) {
    basename(modname, ximp[i], '.');
    if (!strcmp(modname, m))
      return i;
  }
  return NONE;
}

static
add_import(s)
     char *s;
{
  int mno;
  char modname[MAXSTRLEN], fname[MAXSTRLEN], fname2[MAXSTRLEN],
    aname[MAXSTRLEN];
  if (!s) return 0;
  basename(modname, s, '.');
  if ((mno = getmodno(modname)) != NONE && 
      (mno == 0 || mno == mainno || globs[mno])) {
    printf("module %s already imported\n", modname);
    free(s);
    return 0;
  }
  if (search_import(modname) != NONE) {
    printf("module %s already imported\n", modname);
    free(s);
    return 0;
  }
  absname(aname, searchlib(fname, s));
  if (!chkfile(aname)) {
    strcat(strcpy(fname2, s), ".q");
    absname(aname, searchlib(fname, fname2));
  }
  if (!chkfile(aname)) {
    printf("file %s not found\n", s);
    free(s);
    return 0;
  }
  if (ximpsz >= aximpsz) {
    char **ximp1;
    if (!(ximp1 = arealloc(ximp, aximpsz, 10, sizeof(char*)))) {
      printf("error processing %s -- out of memory\n", s);
      free(s);
      return 0;
    } else {
      ximp = ximp1;
      aximpsz += 10;
    }
  }
  ximp[ximpsz++] = s;
  return 1;
}

extern char *source;

static
del_import(s)
     char *s;
{
  char modname[MAXSTRLEN], fname[MAXSTRLEN], fname2[MAXSTRLEN],
    aname[MAXSTRLEN];
  int i, mno, pos;
  if (!s) return 0;
  basename(modname, s, '.');
  absname(aname, searchlib(fname, s));
  if (!chkfile(aname)) {
    strcat(strcpy(fname2, s), ".q");
    absname(aname, searchlib(fname, fname2));
  }
  pos = search_import(modname);
  mno = getmodno(modname);
  if (mno != NONE && mno != mainno && mno != 0 && !globs[mno])
    mno = NONE;
  if (mno != NONE && strcmp(aname, strsp+fnametb[mno])) {
    printf("module %s not imported\n", modname);
    return 0;
  }
  if (mno == NONE || pos == NONE && mno != mainno) {
    if (mno != NONE)
      printf("module %s cannot be unloaded\n", modname);
    else
      printf("module %s not imported\n", modname);
    return 0;
  }
  if (mno == mainno)
    source = NULL;
  if (pos != NONE) {
    free(ximp[pos]);
    for (i = pos+1; i < ximpsz; i++)
      ximp[i-1] = ximp[i];
    ximpsz--;
  }
  return 1;
}

static
clear_imports()
{
  if (ximpsz) {
    int i;
    for (i = 0; i < ximpsz; i++)
      free(ximp[i]);
    ximpsz = 0;
    return 1;
  } else
    return 0;
}

static
modcmp(v1, v2)
	int	       *v1, *v2;
{
	return strcmp(strsp + modtb[*v1], strsp + modtb[*v2]);
}

static
print_modlist()
{
  int i, *v;
  if (modtbsz <= 0)
    return;
  else if (!(v = (int *)calloc(modtbsz, sizeof(int)))) {
    thr->qmstat = MEM_OVF;
    return;
  }
  for (i = 0; i < modtbsz; i++) v[i] = i;
  qsort(v, modtbsz, sizeof(int), (int(*)())modcmp);
  if (iflag) {
    for (i = 0; i < modtbsz; i++) {
      if (i > 0)
	if (i % 4 == 0)
	  printf("\n");
	else
	  printf("\t");
      if (dll_name[v[i]]) {
	char modn[MAXSTRLEN];
	strcat(strcpy(modn, strsp+modtb[v[i]]), "*");
	printf("%-15s", modn);
      } else
	printf("%-15s", strsp+modtb[v[i]]);
    }
    printf("\n");
  } else {
    for (i = 0; i < modtbsz; i++)
      printf("%s%s\n", strsp+modtb[v[i]], dll_name[v[i]]?"*":" ");
  }
  free(v);
}

static modules()
{
  if (!checkbrk) {
    print_modlist();
  }
  savepos();
  return clean();
}

static
print_implist()
{
  int i, n = 0, *v;
  for (i = 0; i < modtbsz; i++) 
    if (i == 0 || i == mainno || globs[i])
      n++;
  if (n <= 0)
    return;
  else if (!(v = (int *)calloc(n, sizeof(int)))) {
    thr->qmstat = MEM_OVF;
    return;
  }
  n = 0;
  for (i = 0; i < modtbsz; i++) 
    if (i == 0 || i == mainno || globs[i])
      v[n++] = i;
  qsort(v, n, sizeof(int), (int(*)())modcmp);
  if (iflag) {
    for (i = 0; i < n; i++) {
      char modn[MAXSTRLEN];
      if (i > 0)
	if (i % 4 == 0)
	  printf("\n");
	else
	  printf("\t");
      sprintf(modn, "%s%s%s",
	      (v[i] == mainno||search_import(strsp+modtb[v[i]])!=NONE)?"+":"",
	      strsp+modtb[v[i]], dll_name[v[i]]?"*":" ");
      printf("%-15s", modn);
    }
    printf("\n");
  } else {
    for (i = 0; i < n; i++)
      printf("%s%s%s\n",
	     (v[i] == mainno||search_import(strsp+modtb[v[i]])!=NONE)?"+":"",
	     strsp+modtb[v[i]], dll_name[v[i]]?"*":" ");
  }
  free(v);
}

static import_list()
{
  if (!checkbrk) {
    print_implist();
  }
  savepos();
  return clean();
}

static
idcmp(v1, v2)
     int	       *v1, *v2;
{
  int cmp = strcmp(strsp + symtb[*v1].pname, strsp + symtb[*v2].pname);
  if (cmp)
    return cmp;
  else
    return strcmp(strsp + modtb[symtb[*v1].modno],
		  strsp + modtb[symtb[*v2].modno]);
}

static
print_varlist()
{
  int	       *v, n, i;
  char		s[MAXSTRLEN];
  for (n = 0, i = BINARY; i < symtbsz+tmptbsz; i++)
    if (visible(i) && symtb[i].x)
      n++;
  if (n == 0) {
    /* 		printf("*** no defined symbols ***\n"); */
    return;
  } else if (!(v = (int *)calloc(n, sizeof(int)))) {
    thr->qmstat = MEM_OVF;
    return;
  }
  for (n = 0, i = BINARY; i < symtbsz+tmptbsz; i++)
    if (visible(i) && symtb[i].x)
      v[n++] = i;
  qsort(v, n, sizeof(int), (int(*)())idcmp);
  if (iflag) {
    for (i = 0; i < n; i++) {
      if (i > 0)
	if (i % 4 == 0)
	  printf("\n");
	else
	  printf("\t");
      printf("%-15s", pname(s, v[i]));
    }
    printf("\n");
  } else {
    for (i = 0; i < n; i++)
      printf("%s\n", pname(s, v[i]));
  }
  free(v);
}

static who()
{
  if (!checkbrk) {
    print_varlist();
  }
  savepos();
  return clean();
}

static whos(sym)
     int sym;
{
  printf("\n");
  if (sym >= BINARY) {
    int mno = symtb[sym].modno,
      flags = symtb[sym].flags,
      argc = symtb[sym].argc,
      type = symtb[sym].type;
    unsigned long argv = symtb[sym].argv;
    EXPR *x = (EXPR*)symtb[sym].x;
    char s[MAXSTRLEN], ts[MAXSTRLEN];
    
    pname(s, sym);
    if (type) pname(ts, type);
    if (mno == NONE || sym < BUILTIN || !(flags & DCL)) {
      if ((flags & VSYM) && !x)
	printf("%-15s\tnot a defined symbol", s);
      else
	printf("%-15s\t%s %s%s symbol", s,
	       (sym<BUILTIN)?"builtin":"user-defined",
	       argv?"special ":"",
	       (flags&VSYM)?"variable":
	       (flags&CST)?(argc==0?"constant":"constructor"):
	       "function");
      if ((flags&EXT) && symtb[sym].xfno!=sym)
	printf("\n%-15s\texternal override in %s", " ",
	       strsp+fnametb[symtb[symtb[sym].xfno].modno]);
    } else {
      printf("%-15s\t%s%s%s symbol defined in %s", s,
	     (flags&PRIV)?"private ":"",
	     argv?"special ":"",
	     (flags&VSYM)?"variable":
	     (flags&CST)?(argc==0?"constant":"constructor"):
	     ((flags&EXT)&&symtb[sym].xfno==sym)?"external function":
	     "function",
	     strsp+fnametb[mno]);
      if ((flags&EXT) && symtb[sym].xfno!=sym)
	printf("\n%-15s\texternal override in %s", " ",
	       strsp+fnametb[symtb[symtb[sym].xfno].modno]);
    }
    if (type)
      printf("\n%-15s\t%s %s", " ", ts, s);
    else if (argc > 0)
      printf("\n%-15s\t%s", " ", s);
    if (argc > 0) {
      int i;
      for (i = 0; i < argc; i++) {
	printf(" ");
	if (argv && !((argv>>i)&1)) printf("~");
	printf("$%d", i+1);
      }
    }
    if (type) {
      int tmno = symtb[type].modno;
      if (tmno == NONE || type < BUILTIN)
	printf("\n%-15s\tbuiltin type %s", " ", ts);
      else
	printf("\n%-15s\t%s%stype %s defined in %s", " ",
	       (symtb[type].flags&PRIV)?"private ":"",
	       (symtb[type].flags&EXT)?"external ":"", ts,
	       strsp+fnametb[tmno]);
    } else if (x) {
      printf("\n%-15s\t= ", " ");
      printx(x);
    }
    printf("\n");
  } else
    printf("unknown or bad symbol\n");
  savepos();
  return clean();
}

/* make the parser reentrant */

static struct {
  int yychar, yynerrs;
  YYSTYPE yylval;
  THREAD *thr;
} yystack[MAXSTACK], *yystptr = NULL;

static yypush()
{
  if (yystptr) {
    if (yystptr - yystack >= MAXSTACK)
      fatal("source stack overflow");
    yystptr->yychar = yychar;
    yystptr->yynerrs = yynerrs;
    memcpy(&yystptr->yylval, &yylval, sizeof(YYSTYPE));
    yystptr->thr = thr;
    yystptr++;
  } else
    yystptr = yystack;
}

static yypop()
{
  if (yystptr > yystack) {
    --yystptr;
    yychar = yystptr->yychar;
    yynerrs = yystptr->yynerrs;
    memcpy(&yylval, &yystptr->yylval, sizeof(YYSTYPE));
    thr = yystptr->thr;
  } else
    yystptr = NULL;
}

/* generic parse routine: */

static parse(source, _mode)
     void	       *source;
     int		_mode;
{
  int c, actmode;
  long xbp;
  THREAD *_thr = get_thr();
  actmode = _thr->mode;
  xbp = _thr->xsp-_thr->xst;
  if (!initlex(source, _mode)) {
    _thr->qmstat = STACK_OVF;
    return 0;
  };
  yypush();
  thr = _thr;
  thr->mode = 1;
  if (_mode == INTERACT || _mode == SOURCE)
    base = (char*)source;
  else
    base = NULL;	
  if (yyparse()) {
    if (_mode == INTERACT || _mode == SOURCE) savepos();
    if (_mode == LINE)
      /* skip remainder of input line */
      if (yychar && yychar != 10 && (thr > thr0 || !checkbrk)) skip();
    finilex();
    yypop();
    thr->debug = debug;
    /* clean up the stack: */
    while (thr->xsp-thr->xst > xbp)
      qmfree(thr, *--thr->xsp);
    thr->mode = actmode;
    return (0);
  } else {
    if (_mode == INTERACT || _mode == SOURCE) savepos();
    finilex();
    thr->debug = debug;
    yypop();
    thr->mode = actmode;
    return (1);
  }
}

/* interface routines: */

int sparsex(char *s)
{
  return parse(s, STRING);
}

int fparsex(FILE *fp)
{
  THREAD *thr = get_thr();
  if (parse(fp, LINE))
    if (thr == thr0 && checkbrk) {
      qmfree(thr, *--thr->xsp);
      return 0;
    } else
      return 1;
  else
    return 0;
}

int parsesrc(char *fname, int chk)
{
  extern char *getline();
  char *buf;
  FILE *fp;
  THREAD *thr = get_thr();
  if (!chkfile(fname) || !(fp = fopen(fname, "r"))) {
    char msg[MAXSTRLEN];
    sprintf(msg, qmmsg[FILE_NOT_FOUND], fname);
    error(msg);
    return 0;
  }
  psource = fname;
  actlineno = 0;
  while (!quitflag && thr->qmstat != QUIT && (buf = getline(fp, ""))) {
    if (eflag) echo(buf);
    if (!parse(buf, SOURCE)) {
      if (thr->qmstat == BAD_OBJ) thr->qmstat = chk?SYNTAX_ERR:OK;
      clean();
      free(buf);
      return 0;
    }
    free(buf);
    fflush(stderr);
    fflush(stdout);
    fflush(NULL);
  }
  fclose(fp);
  return 1;
}

int parsex(char *s)
{
  if (!parse(s, INTERACT))
    return clean();
  else
    return 1;
}
