
/* graphics_except.q: exception handling for the graphics module 03-04-02 AG */

/* see except.q for explanation */

/* This file is part of the Q programming system.

   The Q programming system is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   The Q programming system is distributed in the hope that it will be
   useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

@-0x80000000

import graphics;

public type GraphicsException : Exception = special const graphics_err X;

moveto X Y		= throw (graphics_err (moveto X Y));
rmoveto DX DY		= throw (graphics_err (rmoveto DX DY));
lineto X Y		= throw (graphics_err (lineto X Y));
rlineto DX DY		= throw (graphics_err (rlineto DX DY));
curveto X1 Y1 X2 Y2 X3 Y3
			= throw (graphics_err (curveto X1 Y1 X2 Y2 X3 Y3));
rcurveto DX1 DY1 DX2 DY2 DX3 DY3
			= throw (graphics_err
				 (rcurveto DX1 DY1 DX2 DY2 DX3 DY3));
arc X Y R A1 A2		= throw (graphics_err (arc X Y R A1 A2));
narc X Y R A1 A2	= throw (graphics_err (narc X Y R A1 A2));
arct X1 Y1 X2 Y2 R	= throw (graphics_err (arct X1 Y1 X2 Y2 R));
charpath S T		= throw (graphics_err (charpath S T));
show S			= throw (graphics_err (show S));
translate TX TY		= throw (graphics_err (translate TX TY));
scale SX SY		= throw (graphics_err (scale SX SY));
rotate A		= throw (graphics_err (rotate A));
setlinewidth X		= throw (graphics_err (setlinewidth X));
setlinecap N		= throw (graphics_err (setlinecap N));
setlinejoin N		= throw (graphics_err (setlinejoin N));
setdash Xs DX		= throw (graphics_err (setdash Xs DX));
setgray N		= throw (graphics_err (setgray N));
setrgbcolor R G B	= throw (graphics_err (setrgbcolor R G B));
sethsbcolor H S B	= throw (graphics_err (sethsbcolor H S B));
setcmykcolor C M Y K	= throw (graphics_err (setcmykcolor C M Y K));
setfont S X		= throw (graphics_err (setfont S X));
setcolor C		= throw (graphics_err (setcolor C));
copies N		= throw (graphics_err (copies N));
psfile S		= throw (graphics_err (psfile S));
psstr S			= throw (graphics_err (psstr S));
ps S			= throw (graphics_err (ps S));
